%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define poker_user poker
%define selinux_variants mls strict targeted
%define selinux_policyver %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp)
%define policy_name poker-server


Name:             poker-network
Version:          1.6.0
Release:          2%{?dist}
Summary:          Base package for poker client and server

Group:            Applications/Internet
License:          GPLv2+
URL:              http://pokersource.org/poker-network
Source0:          http://download.gna.org/pokersource/sources/%{name}-%{version}.tar.gz

Source10:         poker-server.init
Source11:         poker-bot.init

Source20:         poker-server-README.Fedora
Source21:         poker-web-README.Fedora
Source22:         poker-bot-README.Fedora

Source30:         poker-server-selinux
Source31:         poker-bot-selinux

Source40:         poker-server.te
Source41:         poker-server.fc
Source42:         poker-server.if

Patch0:           %{name}-1.0.33-bot.patch

BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:        noarch
BuildRequires:    python-devel selinux-policy-devel checkpolicy hardlink
BuildRequires:    python-twisted-web pyOpenSSL poker-engine-devel >= 1.0.21
Requires:         python-twisted-web pyOpenSSL poker-engine >= 1.0.21
Requires:         python-simplejson

%if "%{selinux_policyver}" != ""
Requires:         selinux-policy >= %{selinux_policyver}
%endif


%description
%{summary}.

%package -n poker-client-lib
Summary:          Poker network client library
Group:            Development/Libraries
Requires:         %{name} = %{version}-%{release}

%description -n poker-client-lib
The client library can be used to implement simple clients such as
robots (<1000 LOC example robot provided) or a graphical user
interface.

%package -n poker-server
Summary:          Server for %{name}
Group:            Applications/Internet
BuildRequires:    MySQL-python SOAPpy
Requires:         MySQL-python SOAPpy
Requires:         poker-client-lib = %{version}-%{release}
Requires:         %{name} = %{version}-%{release}
Requires(post):   chkconfig
Requires(preun):  chkconfig
Requires(preun):  initscripts

%description -n poker-server
The server deals the cards and checks the user actions using a poker
game engine (poker-engine). It can handle all the poker variants
implemented by the poker game engine (holdem, omaha, omaha high/low,
stud 7 ...) in ring games, sit and go or multitables tournaments.

%package -n poker-web
Summary:          Web interface to a %{name} server
Group:            Applications/Internet
Requires:         httpd php php-mysql php-gd php-bcmath

%description -n poker-web
%{summary}.

%package -n poker-bot
Summary:          Poker playing robots for poker-server
Group:            Applications/Internet
BuildRequires:    apg
Requires:         apg poker-client-lib = %{version}-%{release}
Requires(post):   chkconfig
Requires(preun):  chkconfig
Requires(preun):  initscripts

%description -n poker-bot
%{summary}.

%package selinux
Summary:          SELinux policy files for the poker game server
Group:            Amusements/Games
Requires:         %{name} = %{version}-%{release}
Requires(post):   /usr/sbin/semodule /usr/sbin/semanage /sbin/fixfiles
Requires(preun):  /sbin/service /usr/sbin/semodule /usr/sbin/semanage
Requires(preun):  /sbin/fixfiles /usr/sbin/setsebool
Requires(postun): /usr/sbin/semodule

%description selinux
%{summary}.


%prep
%setup -q
%patch0 -p0 -b .bot~

# prep selinux source files for build
install -d selinux
install -pm 644 %{SOURCE40} %{SOURCE41} %{SOURCE42} selinux


%build
%configure --disable-static --disable-poker2d
make %{?_smp_mflags}

# build selinux policy file
pushd selinux
for variant in %{selinux_variants} ; do
    make NAME=${variant} -f %{_datadir}/selinux/devel/Makefile
    mv %{policy_name}.pp %{policy_name}.pp.${variant}
    make NAME=${variant} -f %{_datadir}/selinux/devel/Makefile clean
done
popd


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# install init scripts
install -d $RPM_BUILD_ROOT%{_initrddir}
install -d $RPM_BUILD_ROOT%{_bindir}
install -pm 755 %{SOURCE10} $RPM_BUILD_ROOT%{_initrddir}/poker-server
install -pm 755 %{SOURCE11} $RPM_BUILD_ROOT%{_initrddir}/poker-bot
install -pm 755 %{SOURCE30} $RPM_BUILD_ROOT%{_bindir}/poker-server-selinux
install -pm 755 %{SOURCE31} $RPM_BUILD_ROOT%{_bindir}/poker-bot-selinux

# fill in substitions for init files
sed -i 's@PYTHON_SITELIB@%{python_sitelib}@' $RPM_BUILD_ROOT%{_bindir}/*-selinux
sed -i 's@PYTHON_SITELIB@%{python_sitelib}@' $RPM_BUILD_ROOT%{_initrddir}/*
sed -i 's@POKER_USER@%{poker_user}@' $RPM_BUILD_ROOT%{_initrddir}/*

# install Fedora README files
install -d poker-server poker-web poker-bot
install -pm 644 %{SOURCE20} ./poker-server/README.Fedora
install -pm 644 %{SOURCE21} ./poker-web/README.Fedora
install -pm 644 %{SOURCE22} ./poker-bot/README.Fedora

# install constants file manually
mv $RPM_BUILD_ROOT%{_datadir}/poker-web/constants.php.ref \
    $RPM_BUILD_ROOT%{_sysconfdir}/poker-web/constants.php
pushd $RPM_BUILD_ROOT%{_datadir}/poker-web
ln -sf ../../..%{_sysconfdir}/poker-web/constants.php
popd

# install .htaccess in etc
install -d $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
cat > $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/poker-web.conf << EOF
Alias /poker-web %{_datadir}/poker-web

<Directory %{_datadir}/poker-web/>
EOF
cat $RPM_BUILD_ROOT%{_sysconfdir}/poker-web/htaccess >> \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/poker-web.conf
echo "</Directory>" >> \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/poker-web.conf
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/poker-web/htaccess
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/poker-web/apache.conf
rm -f $RPM_BUILD_ROOT%{_datadir}/poker-web/.htaccess

# locales and pkgconfig files installed in poker2d
rm -fr $RPM_BUILD_ROOT%{_datadir}/locale
rm -f  $RPM_BUILD_ROOT%{_libdir}/pkgconfig/%{name}.pc

# create log and run directories for poker user id
# log files are auto-rotated, no need for logrotate
install -d $RPM_BUILD_ROOT%{_var}/log/%{name}
install -d $RPM_BUILD_ROOT%{_var}/run/%{name}

# install selinux policies
pushd selinux
for variant in %{selinux_variants} ; do
    install -d $RPM_BUILD_ROOT%{_datadir}/selinux/${variant}
    install -pm 644 %{policy_name}.pp.${variant} \
           $RPM_BUILD_ROOT%{_datadir}/selinux/${variant}/%{policy_name}.pp
done
popd

# hardlink identical policy module packages together
/usr/sbin/hardlink -cv $RPM_BUILD_ROOT%{_datadir}/selinux


%check
# make check is currently non-functional in mock
# upstream is investigating an in-memory db solution for this
#make check

 
%clean
rm -rf $RPM_BUILD_ROOT


%pre -n poker-server
user_uid=`id -u %{poker_user} 2>/dev/null`
if [ x"$user_uid" = x ] ; then
    useradd -r -s /sbin/nologin -d %{_datadir}/%{name} -M \
            -c 'Poker Server' %{poker_user} >/dev/null || :
fi

%post -n poker-server
/sbin/chkconfig --add poker-server

%preun -n poker-server
if [ $1 = 0 ]; then
    /sbin/service poker-server stop >/dev/null 2>&1
    /sbin/chkconfig --del poker-server
fi

%postun -n poker-server
if [ "$1" -ge "1" ]; then
    /sbin/service poker-server condrestart >/dev/null 2>&1 || :
fi

%post -n poker-bot
/sbin/chkconfig --add poker-bot

%preun -n poker-bot
if [ $1 = 0 ]; then
    /sbin/service poker-bot stop >/dev/null 2>&1
    /sbin/chkconfig --del poker-bot
fi

%postun -n poker-bot
if [ "$1" -ge "1" ]; then
    /sbin/service poker-bot condrestart >/dev/null 2>&1 || :
fi

%post selinux
# install selinux policy modules
for selinuxvariant in %{selinux_variants} ; do
  /usr/sbin/semodule -s ${selinuxvariant} -i \
    %{_datadir}/selinux/${selinuxvariant}/%{policy_name}.pp &> /dev/null || :
done
/usr/sbin/semanage port -a -t pokerd_port_t -p tcp 19380-19383 &> /dev/null || :
/sbin/fixfiles -R poker-server,poker-bot restore || :
/usr/sbin/setsebool pokerd_disable_trans 0 &> /dev/null || :
/sbin/service poker-server condrestart > /dev/null 2>&1 || :

%preun selinux
if [ "$1" -lt "1" ] ; then
    # disable the policy and restart the daemon
    /usr/sbin/setsebool pokerd_disable_trans 1 &> /dev/null || :
    /sbin/service poker-server condrestart > /dev/null 2>&1 || :
    # unload the module
    /usr/sbin/semanage port -d -t pokerd_port_t -p tcp 19380-19383 &> /dev/null || :
    for variant in %{selinux_variants} ; do
        /usr/sbin/semodule -s ${variant} -r %{policy_name} &> /dev/null || :
    done
    # set the context back
    /sbin/fixfiles -R poker-server,poker-bot restore || :
fi

%postun selinux
if [ "$1" -ge "1" ] ; then
    # replace the module if it is already loaded. semodule -u also
    # checks the module version
    for variant in %{selinux_variants} ; do
        /usr/sbin/semodule -u %{_datadir}/selinux/${variant}/%{policy_name}.pp || :
    done
fi


%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING HACKING NEWS README
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/conf
%dir %{_datadir}/%{name}/upgrades
%dir %{_sysconfdir}/%{name}
%dir %{python_sitelib}/pokernetwork
%{python_sitelib}/pokernetwork/__init__*
%{python_sitelib}/pokernetwork/dispatch*
%{python_sitelib}/pokernetwork/packets*
%{python_sitelib}/pokernetwork/pokernetworkconfig*
%{python_sitelib}/pokernetwork/pokerpackets*
%{python_sitelib}/pokernetwork/protocol*
%{python_sitelib}/pokernetwork/proxy*
%{python_sitelib}/pokernetwork/upgrade*
%{python_sitelib}/pokernetwork/user*
%{python_sitelib}/pokernetwork/version*

%files -n poker-client-lib
%defattr(-,root,root,-)
%doc COPYING
%config(noreplace) %{_sysconfdir}/%{name}/poker.client.xml
%{_datadir}/%{name}/conf/poker.client.xml
%{_datadir}/%{name}/upgrades/poker.client
%{python_sitelib}/pokerui
%{python_sitelib}/pokernetwork/client*
%{python_sitelib}/pokernetwork/pokerchildren*
%{python_sitelib}/pokernetwork/pokerclient*
%{python_sitelib}/pokernetwork/pokerexplain*
%{python_sitelib}/pokernetwork/pokergameclient*

%files -n poker-server
%defattr(-,root,root,-)
%doc COPYING README poker-server/README.Fedora
%attr(-,%{poker_user},root) %config(noreplace) %{_sysconfdir}/%{name}/poker.server.xml
%config(noreplace) %{_sysconfdir}/%{name}/poker.pem
%{_initrddir}/poker-server
%dir %attr(-,%{poker_user},root) %{_var}/run/%{name}
%dir %attr(-,%{poker_user},root) %{_var}/log/%{name}
%{_bindir}/poker-server-selinux
%{_sbindir}/pokerserver
%{_sbindir}/pokerdatabaseupgrade
%{_mandir}/man8/pokerserver*
%{_mandir}/man8/pokerdatabaseupgrade*
%{_datadir}/%{name}/*.sql
%{_datadir}/%{name}/conf/poker.server.xml
%{_datadir}/%{name}/conf/poker.pem
%{_datadir}/%{name}/upgrades/poker.server
%{_datadir}/%{name}/upgrades/upgrade
%{python_sitelib}/pokernetwork/currencyclient*
%{python_sitelib}/pokernetwork/pokeravatar*
%{python_sitelib}/pokernetwork/pokercashier*
%{python_sitelib}/pokernetwork/pokerdatabase*
%{python_sitelib}/pokernetwork/pokerlock*
%{python_sitelib}/pokernetwork/pokerserver*
%{python_sitelib}/pokernetwork/pokerservice*
%{python_sitelib}/pokernetwork/pokertable*
%{python_sitelib}/pokernetwork/server*

%files -n poker-web
%defattr(-,root,root,-)
%doc COPYING poker-web/README.Fedora
%config(noreplace) %{_sysconfdir}/poker-web
%config(noreplace) %{_sysconfdir}/httpd/conf.d/poker-web.conf
%{_datadir}/poker-web
%{_datadir}/munin/plugins

%files -n poker-bot
%defattr(-,root,root,-)
%doc COPYING poker-bot/README.Fedora
%config(noreplace) %{_sysconfdir}/%{name}/poker.bot.xml
%{_initrddir}/poker-bot
%{_bindir}/poker-bot-selinux
%{_sbindir}/pokerbot
%{_mandir}/man8/pokerbot*
%{_datadir}/%{name}/conf/poker.bot.xml
%{_datadir}/%{name}/upgrades/poker.bot
%{python_sitelib}/pokernetwork/pokerbot*

%files selinux
%defattr(-,root,root,-)
%doc COPYING selinux/*.??
%{_datadir}/selinux/*/%{policy_name}.pp


%changelog
* Thu Oct 09 2008 Christopher Stone <chris.stone@gmail.com> 1.6.0-2
- Update bot patch (bz #464986)

* Thu May 29 2008 Christopher Stone <chris.stone@gmail.com> 1.6.0-1
- Upstream sync

* Sat May 24 2008 Christopher Stone <chris.stone@gmail.com> 1.5.0-3
- Add $syslog to LSB headers on initscripts

* Fri May 23 2008 Christopher Stone <chris.stone@gmail.com> 1.5.0-2
- Conform for fedora initscript standards (bz #247022)

* Fri May 16 2008 Christopher Stone <chris.stone@gmail.com> 1.5.0-1
- Upstream sync
- Remove no longer needed libtool and gettext-devel from BR

* Sun Mar 30 2008 Christopher Stone <chris.stone@gmail.com> 1.4.0-2
- Add poker-client-lib to poker-server Requires (bz #439222)

* Mon Mar 24 2008 Christopher Stone <chris.stone@gmail.com> 1.4.0-1
- Upstream sync
- Remove no longer needed bot patch
- Add apg to BuildRequires

* Thu Dec 13 2007 Christopher Stone <chris.stone@gmail.com> 1.2.0-4
- Add python-simplejson requirement to poker-network package

* Sun Oct 21 2007 Christopher Stone <chris.stone@gmail.com> 1.2.0-3
- Remove devel subpackage and move to poker2d

* Wed Oct 03 2007 Christopher Stone <chris.stone@gmail.com> 1.2.0-2
- Add patch to fix poker-bot

* Wed Oct 03 2007 Christopher Stone <chris.stone@gmail.com> 1.2.0-1
- Upstream sync

* Fri Jul 27 2007 Christopher Stone <chris.stone@gmail.com> 1.1.1-1
- Upstream sync

* Wed May 23 2007 Christopher Stone <chris.stone@gmail.com> 1.0.37-1
- Upstream sync
- Remove no longer needed db patch

* Thu Mar 15 2007 Christopher Stone <chris.stone@gmail.com> 1.0.36-1
- Upstream sync

* Sun Feb 18 2007 Christopher Stone <chris.stone@gmail.com> 1.0.35-2
- Update policy file [attachment (id=148298)]

* Tue Feb 13 2007 Christopher Stone <chris.stone@gmail.com> 1.0.35-1
- Upstream sync
- Add selinux changes from wart
- Remove patches applied upstream

* Fri Jan 26 2007 Christopher Stone <chris.stone@gmail.com> 1.0.34-3
- Use %%{name} where poker-network is found in spec
- Keep poker.server.xml 0600 and update Fedora.README accordingly
- Remove poker-network-init selinux wrapper script
- Create poker-server-selinux and poker-bot-selinux wrapper scripts
- Create poker-server-selinux and poker-bot-selinux sub-packages
- Add sed substitutions to selinux wrapper scripts
- Modify init scripts to check for selinux wrapper script
- Change "mkdir -p" instances to "install -d"

* Wed Jan 24 2007 Christopher Stone <chris.stone@gmail.com> 1.0.34-2
- Write own status function using isrunning to poker-server/bot init
- Fix some errors in init files
- Change %%{poker_user} from games to poker
- Add useradd call in %%pre for poker-server
- Add note in poker-server README about x509 certificate
- Add quotes around sed expression

* Wed Jan 24 2007 Christopher Stone <chris.stone@gmail.com> 1.0.34-1
- Upstream sync
- Add a wrapper script for init files to help SElinux
- invoke wrapper script using daemon --user=POKER_USER
- add sed command to fill in POKER_USER in init files
- remove old config patch which is fixed in this release
- add new config patch to configure as noarch package
- comment out make check in spec
- Remove adduser call in %%pre and use userid of games instead

* Mon Jan 22 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-11
- Remove poker-server and poker-web Requires from poker-bot
- Remove NIHPHOBIA from %%doc
- Remove %%{version} from patch names
- Replace %%{_sysconfdir}/init.d with %%{_initrddir}
- Document relation between currency and URL in poker-web/README.Fedora
- Add a poker-bot/README.Fedora file for explaining cash-in URLs
- Change permissions on poker.server.xml to readable
- Add permission changing to instructions in poker-server/README.Fedora
- Add creation of %%{poker_user} user id to run poker-server
- Create a directory for poker-server log files
- Add poker-server run and log directories to poker-server %%files
- Change ownership of poker-server run/log directories to %%{poker_user}

* Sun Jan 21 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-10
- Add better pid file checking in init scripts
- Add FLUSH PRIVILEGES to poker-web README.Fedora
- Add another CREATE USER statement to README.Fedora for localhost
- Add patch to properly create users in pokerdatabase.py

* Sat Jan 20 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-9
- Fix init scripts, PYTHON_SITELIB substituion macro got lost
- Re-word poker-web README.Fedora file reflecting new changes

* Sat Jan 20 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-8
- Readd poker-client-lib package to this spec file
- Readd %%{release} to packages that require poker-client-lib
- Remove manual removal of files since they are all in poker-client-lib
- Update comments on rpmlint errors

* Sat Jan 20 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-7
- Create a httpd poker-web.conf file from the .htaccess file
- Remove existing htaccess and apache.conf files
- Add new apache conf to %%files in poker-web
- Make symlink to constants.php relative

* Fri Jan 19 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-6
- Add php to poker-web Requires (php-mysql does not pull it in)
- Add patch to fix --disable-poker2d config option
- Use --disable-poker2d option to reduce manually removing some files
- Remove no longer needed BuildRequires for poker2d package

* Fri Jan 19 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-5
- Remove webclient from poker-web Requires
- Remove %%{release} from poker-client-lib Requires for poker-bot
- Fix init scripts to work for different python releases
- Remove redundant python-twisted-core from BuildRequires

* Tue Jan 16 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-4
- Add php-mysql and php-gd to Requires for poker-web

* Tue Jan 16 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-3
- Do not glob removal of files under %%{python_sitearch}
- Change Requires from php to php-bcmath for poker-web

* Sun Jan 14 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-2
- Split out poker-client-lib/poker2d files into another spec file
- Add Requires apg and poker-web to poker-bot
- No longer remove symlinks for constants.php and htaccess
- Create a README.Fedora for poker-web package
- Reduce initial number of bots to four due to a bug

* Thu Jan 11 2007 Christopher Stone <chris.stone@gmail.com> 1.0.33-1
- Upstream sync
- Add %%find_lang for new locales

* Wed Jan 10 2007 Christopher Stone <chris.stone@gmail.com> 1.0.32-8
- Move poker-interface to %%{_libexecdir}
- Package poker-interface with poker-client-lib
- Remove no longer needed shared lib patch

* Wed Jan 10 2007 Christohper Stone <chris.stone@gmail.com> 1.0.32-7
- Keep permssions 600 for poker.server.xml file

* Fri Jan 05 2007 Christopher Stone <chris.stone@gmail.com> 1.0.32-6
- Replace pkgconfig with poker-eval-devel

* Tue Jan 02 2007 Christopher Stone <chris.stone@gmail.com> 1.0.32-5
- Move poker-interface to %%{python_sitearch}/pokerclient2d
- Fix configure options
- Remove TODO comments

* Sun Dec 31 2006 Christopher Stone <chris.stone@gmail.com> 1.0.32-4
- Add full path to exec in desktop file
- Add pkgconfig to devel subpackage
- Convert icons to png format and store in icons directory
- Update TODO comments

* Fri Dec 29 2006 Christopher Stone <chris.stone@gmail.com> 1.0.32-3
- Update BR/R to new python-twisted stack

* Mon Dec 18 2006 Christopher Stone <chris.stone@gmail.com> 1.0.32-2
- Remove semanage call in init file until an selinux policy is written
- Add comment to %%check section indicating that it is not functional
- Update TODO comments

* Sun Dec 17 2006 Christopher Stone <chris.stone@gmail.com> 1.0.32-1
- Initial RPM release
